-- Informatics 1 - Functional Programming 
-- FP Comp


import LSystem

-- Joins a list of commands into a single command

join :: [Command] -> Command
join [] = Sit
join (x:xs) 
     	    | xs == []  = (x)
     	    | x /= Sit  = x :#: join xs   
  	    | otherwise = x :#: join xs

-- Copies a command a given number of times

copy :: Int -> Command -> Command
copy int command = join (replicate int command)

-- Draws a lambda of a given colour

lambda :: Pen -> Command
lambda colour = Turn (-8) :#: copy 8 (GrabPen colour :#: Go 2 :#: Turn (-20)) :#: Go 6 :#: Branch (Go 14 :#: copy 8 (GrabPen colour :#: Go 2 :#: Turn 20)) :#: Branch (Turn (-40) :#: Go calc)

-- Calculates the length of the lambda leg

calc :: Float
calc = ((14 + (pi / 18)) - ((pi / 9) * (sin (20 / 2)))) / (sin 40) 

-- Draws a lambda, made of lambdas

lambdaOne :: Pen -> Command
lambdaOne colour = Turn (-8) :#: join [(GrabPen Inkless :#: Branch (Turn (20 * n) :#: lambda colour) :#: Go 30 :#: Turn (-20))| n <- [0..7]] :#: Go 10 :#: copy 6 (GrabPen Inkless :#: Branch (Turn 160 :#: lambda colour :#: Turn (-160)) :#: Go 40) :#: Branch (Turn (-40) :#: copy 18 (GrabPen Inkless :#: Branch (Turn 200 :#: lambda colour :#: Turn (-200)) :#: Go 40)) :#: copy 14 (GrabPen Inkless :#: Branch (Turn 160 :#: lambda colour :#: Turn (-160)) :#: Go 40) :#: Go 5 :#: join [(GrabPen Inkless :#: Branch (Turn (180 - (20 * n)) :#: lambda colour) :#: Go 40 :#: Turn 20)| n <- [0..7]]

-- Draws a lambda, made of lambdas, made of lambdas
-- Not used in the end because caused a stack overflow 
-- when used in the function lambda3D

lambdaTwo :: Pen -> Distance -> Command
lambdaTwo colour x = Turn (-8) :#: join [(GrabPen Inkless :#: Branch (Turn (20 * n) :#: lambdaOne colour) :#: Go (30 * x) :#: Turn (-20))| n <- [0..7]] :#: Go (10 * x) :#: copy 6 (GrabPen Inkless :#: Branch (Turn 160 :#: lambdaOne colour :#: Turn (-160)) :#: Go (40 * x)) :#: Branch (Turn (-40) :#: copy 18 (GrabPen Inkless :#: Branch (Turn 200 :#: lambdaOne colour :#: Turn (-200)) :#: Go (40 * x))) :#: copy 14 (GrabPen Inkless :#: Branch (Turn 160 :#: lambdaOne colour :#: Turn (-160)) :#: Go (40 * x)) :#: Go (5 * x) :#: join [(GrabPen Inkless :#: Branch (Turn (180 - (20 * n)) :#: lambdaOne colour) :#: Go (40 * x) :#: Turn 20)| n <- [0..7]]

-- Draws a lambda made of lambdas and then returns up and right 
-- of the starting postion

lambda3D :: Distance -> Distance -> Pen -> Command
lambda3D a b pen = Branch (lambdaOne pen) :#: GrabPen Inkless :#: Go a :#: Turn (-90) :#: Go b :#: Turn 90

-- Utilises lambda3D to draw a 3D lambda made of lambdas made of 
-- lambdas going from the colour blue to green

multiColourLambda3D :: Command
multiColourLambda3D = join ( concat (map (\n -> [lambda3D 2 3 (Colour 0 (1-n) n)]) [0,(1/90)..1]))

-- Just for ease of tyoing when running the final image

comp :: Command
comp = multiColourLambda3D
